#include "stdafx.h"

double ContinuousAreaCartogramConstruction::TIN_Area(const double Error_desired, double *myu, co_vector &coord, T_vector &T, E_vector &E_Outer)
{
	int i, j;
	double A_Error;
	E_vector calc_E_Outer(E_Outer.begin(), E_Outer.end());
	T_vector::iterator itr;
	co_vector calc;
	i_vector calc_V_ID;
	vector<bool> V_ID_use(coord.size(), false);

	// JgO쐬vZɎgpĂ钸_𒲂ׂ
	for (itr = T.begin(); itr<T.end(); itr++)
		for (i=0; i<3; i++)
			V_ID_use[(*itr).V[i]] = true;

	// JgOW̌_ݒ
	i=0;
	while ((!V_ID_use[i]) && i<int(coord.size())) i++;

	for (j=i; j<int(coord.size()); j++){
		if (V_ID_use[j]){
			calc.push_back(coord[j] - coord[i]);
			calc_V_ID.push_back(j);
		}
	}

	// Op`̒_XgvZp̒_IDōXV
	for (itr=T.begin(); itr<T.end(); itr++)
		for (i=0; i<3; i++)
			(*itr).V[i] = int(lower_bound(calc_V_ID.begin(), calc_V_ID.end(), (*itr).V[i]) - calc_V_ID.begin());

	// Oӂ̒_XgvZp̒_IDōXV
	for (E_vector::iterator itr_E = calc_E_Outer.begin(); itr_E < calc_E_Outer.end() ; itr_E++)
		for (i=0; i<2; i++)
			(*itr_E).V[i] = int(lower_bound(calc_V_ID.begin(), calc_V_ID.end(), (*itr_E).V[i]) - calc_V_ID.begin());

	// JgO쐬vZ
	A_Error = TIN_Area_main(Error_desired, myu, calc, T, calc_E_Outer, calc_V_ID);

	// vZʂ̔f
	for (i=0; i<int(calc.size()); i++) coord[calc_V_ID[i]] = calc[i];

	return A_Error;
}

double ContinuousAreaCartogramConstruction::TIN_Area_main(const double Error_desired, double *myu, co_vector &calc, T_vector &T, E_vector &E_Outer, i_vector &calc_V_ID)
{
	int iter=0, effective_iter=0, j;
	MKL_INT i, A_sp_element, X_row = 2*(int(calc.size()) - 1);
	MKL_INT *A_columns, *A_rowIndex, *perm;
	double *y, *answer, *A_sp;
	double Error = Error_desired * 2, Total_Data = 0.0, new_Error, old_Error;
	co_vector tmp_coord(calc.begin(), calc.end());

	//---ӂIDݒEOpԂ̕ӒvZ
	E_vector E;
	E.reserve(2*int(T.size())+1);
	co_vector Edge_vec(Set_Edge_ID(E, T));
	calc_E_vector(calc, Edge_vec, E);

	//---ʐςɍ킹ĊgEk
	Expand_Area(&Total_Data, Edge_vec, calc, T);

	//---vZps̐ݒ
	y = new double[X_row];
	answer = new double[X_row];
	perm = new MKL_INT[X_row];
	A_rowIndex = new MKL_INT[X_row+1];
	d_matrix X(X_row, vector<double>());
	i_matrix X_ID(X_row, vector<int>());

	//---vZJn
	while ((Error>Error_desired)&&(iter - effective_iter < 1)){
		++ iter;

		//
		fill(y, y+X_row, 0.0);
		for (i=0; i<X_row; i++) fill(X[i].begin(), X[i].end(), 0.0);

		AreaCarto_Expl_Matrix(X, X_ID, y, Edge_vec, calc, E, X_row, *myu, T);

		A_sp_element=0;
		for (i=0; i<X_row; i++) A_sp_element += int(X_ID[i].size());

		A_sp = new double[A_sp_element];
		A_columns = new MKL_INT[A_sp_element];

		A_sp_element = 0;
		for (i=0; i<X_row; i++){
			A_rowIndex[i]=A_sp_element+1;
			copy(X[i].begin(), X[i].end(), A_sp+A_sp_element);

			for (j=0; j<int(X_ID[i].size()); j++){
				A_columns[A_sp_element]=X_ID[i][j]+1;
				A_sp_element ++;
			}
		}
		A_rowIndex[X_row]=A_sp_element+1;

		/* Matrix data. */
		MKL_INT mtype = 11; /* Ώ̍s */
		MKL_INT nrhs = 1; /* Number of right hand sides. */

		/* Internal solver memory pointer pt, */
		/* 32-bit: int pt[64]; 64-bit: long int pt[64] */
		/* or void *pt[64] should be OK on both architectures */
		void *pt[64];
		/* Pardiso control parameters. */
		MKL_INT iparm[64];
		MKL_INT maxfct, mnum, phase, error, msglvl;
		/* Auxiliary variables. */
		double ddum; /* Double dummy */
		MKL_INT idum; /* Integer dummy. */
	/* -------------------------------------------------------------------- */
	/* .. Setup Pardiso control parameters. */
	/* -------------------------------------------------------------------- */
		for (i = 0; i < 64; i++) iparm[i] = 0;

		iparm[0] = 0; /* Solver default */
		//iparm[0] = 1; /* No solver default */
		//iparm[1] = 2; /* Fill-in reordering from METIS */
		//iparm[2] = 2; /* Numbers of processors, value of OMP_NUM_THREADS */
		//iparm[3] = 0; /* No iterative-direct algorithm */
		//iparm[4] = 0; /* No user fill-in reducing permutation */
		//iparm[5] = 0; /* Write solution into x */
		//iparm[6] = 0; /* Not in use */
		//iparm[7] = 10; /* Max numbers of iterative refinement steps */
		//iparm[8] = 0; /* Not in use */
		//iparm[9] = 13; /* Perturb the pivot elements with 1E-13 */
		//iparm[10] = 1; /* Use nonsymmetric permutation and scaling MPS */
		//iparm[11] = 0; /* Not in use */
		//iparm[12] = 0; /* Not in use */
		//iparm[13] = 0; /* Output: Number of perturbed pivots */
		//iparm[14] = 0; /* Not in use */
		//iparm[15] = 0; /* Not in use */
		//iparm[16] = 0; /* Not in use */
		//iparm[17] = -1; /* Output: Number of nonzeros in the factor LU */
		//iparm[18] = -1; /* Output: Mflops for LU factorization */
		//iparm[19] = 0; /* Output: Numbers of CG Iterations */
		maxfct = 1; /* Maximum number of numerical factorizations. */
		mnum = 1; /* Which factorization to use. */
		msglvl = 0; /* Print statistical information in file */
		error = 0; /* Initialize error flag */
	/* -------------------------------------------------------------------- */
	/* .. Initialize the internal solver memory pointer. This is only */
	/* necessary for the FIRST call of the PARDISO solver. */
	/* -------------------------------------------------------------------- */
		for (i = 0; i < 64; i++) pt[i] = 0;

	/* -------------------------------------------------------------------- */
	/* .. Reordering and Symbolic Factorization. This step also allocates */
	/* all memory that is necessary for the factorization. */
	/* -------------------------------------------------------------------- */
		phase = 13;
		PARDISO (pt, &maxfct, &mnum, &mtype, &phase, &X_row, A_sp, A_rowIndex, A_columns, &idum, &nrhs, iparm, &msglvl, y, answer, &error);
		if (error != 0) {
			printf("\nERROR during symbolic factorization: %d", error);
			exit(1);
		}

		delete[] A_sp;
		delete[] A_columns;

	/* -------------------------------------------------------------------- */
	/* .. Termination and release of memory. */
	/* -------------------------------------------------------------------- */
		phase = -1; /* Release internal memory. */
		PARDISO (pt, &maxfct, &mnum, &mtype, &phase, &X_row, &ddum, A_rowIndex, A_columns, &idum, &nrhs, iparm, &msglvl, &ddum, &ddum, &error);

		Renew_coord(int(calc.size())-1, tmp_coord, answer);

		calc_E_vector(tmp_coord, Edge_vec, E);
		Triangle_Area(Edge_vec, T);

		// OpԈʑj̗LmF
		if (TIN_Topology(myu, tmp_coord, calc, Edge_vec, E, E_Outer, T, calc_V_ID)){
			// ʑjȂ
			Error = Error_Ratio(Total_Data, T);
			cout << "iteration " << iter << "  Error 䗦  " << Error << "  myu=" << *myu << endl;

			std::copy(tmp_coord.begin(), tmp_coord.end(), calc.begin());

			new_Error = Squared_Errors(T);
			if (effective_iter != 0) *myu *= new_Error / old_Error * 0.8;
			old_Error = new_Error;
			++ effective_iter;
		}
		// ʑj  xڂ̌vZOpԂŏdݑ ČvZ
		else if (iter == 1){
				iter = 0;
				*myu *= 1.5;
				cout<<"d݂𑝉 myu="<<*myu<<endl;
		}
	}

	copy(tmp_coord.begin(), tmp_coord.end(), calc.begin());

	for (i=0; i<X_row; i++){
		X[i].clear();
		X_ID[i].clear();
	}
	X.clear();
	X_ID.clear();
	tmp_coord.clear();
	delete[] y;
	delete[] answer;
	delete[] perm;
	delete[] A_rowIndex;

	return Error;
}

//---ʐςvZCWg傷 t̎Op`ʐρEf[^
void ContinuousAreaCartogramConstruction::Expand_Area(double *Total_Data, co_vector &Edge_vec, co_vector &coord, T_vector &T)
{
	co_vector::iterator itr_co;
	T_vector::iterator itr_T;
	double Expand, Expand_sq, Total_Area = 0.0;

	for (itr_T=T.begin(); itr_T<T.end(); itr_T++){
		Total_Area += fabs((*itr_T).Area);
		*Total_Data += fabs((*itr_T).Data);
	}

	Expand_sq = *Total_Data/Total_Area;
	Expand = sqrt(Expand_sq);

	for (itr_co=Edge_vec.begin(); itr_co<Edge_vec.end(); itr_co++) *itr_co = *itr_co * Expand;
	for (itr_co=coord.begin(); itr_co<coord.end(); itr_co++) *itr_co = *itr_co * Expand;
	for (itr_T=T.begin(); itr_T<T.end(); itr_T++) (*itr_T).Area *= Expand_sq;
}

//---Op`̖ʐςvZ-----
void ContinuousAreaCartogramConstruction::Triangle_Area(co_vector &Edge_vec, T_vector &T)
{
	for (T_vector::iterator itr=T.begin(); itr<T.end(); itr++)
		(*itr).Area = (Edge_vec[(*itr).E[0]].x * Edge_vec[(*itr).E[1]].y - Edge_vec[(*itr).E[1]].x * Edge_vec[(*itr).E[0]].y)/2;
}

//OpԂ̈ʑj󂳂ĂȂ肷
//j󂳂ĂƂɂ͏d݂𑝉EvZO̍Wɂǂ
bool ContinuousAreaCartogramConstruction::TIN_Topology(double *myu, co_vector &new_coord, co_vector &old_coord, co_vector &Edge_vec, E_vector &E, E_vector &E_Outer, T_vector &T, i_vector &calc_V_ID)
{
	const double powered = 1.2;

	if (!TIN_TopologyCheck(new_coord, E_Outer, T, calc_V_ID)){
		*myu *= powered;
		cout<<"d݂𑝉 myu="<<*myu<<endl;
		copy(old_coord.begin(), old_coord.end(), new_coord.begin());
		calc_E_vector(new_coord, Edge_vec, E);
		Triangle_Area(Edge_vec, T);

		return false;
	}
	return true;
}

// OpԈʑjEOӌ̔
bool ContinuousAreaCartogramConstruction::TIN_TopologyCheck(co_vector &new_coord, E_vector &E_Outer, T_vector &T, i_vector &calc_V_ID)
{
	ContinuousAreaCartogramUtility Util;

	//Op`]͖ʐς̕̕ωŔ
	for (T_vector::iterator itr_T = T.begin(); itr_T < T.end(); itr_T++){
		if ((*itr_T).Data * (*itr_T).Area < 0){
			cout<<"Op ʑj"<<endl;
			return false;
		}
	}

	for (E_vector::iterator itr_E0 = E_Outer.begin(); itr_E0 < E_Outer.end()-1; itr_E0++){
		for (E_vector::iterator itr_E1 = E_Outer.begin()+1; itr_E1 < E_Outer.end(); itr_E1++){
			if (Util.intersect((*itr_E0).V[0], (*itr_E0).V[1], (*itr_E1).V[0], (*itr_E1).V[1], new_coord)){
				cout<<"O  "<<calc_V_ID[(*itr_E0).V[0]]<<'-'<<calc_V_ID[(*itr_E0).V[1]]
					<<','<<calc_V_ID[(*itr_E1).V[0]]<<'-'<<calc_V_ID[(*itr_E1).V[1]]<<endl;
				return false;
			}
		}
	}

	return true;
}


//ӂIDݒ
int ContinuousAreaCartogramConstruction::Set_Edge_ID(E_vector &E, T_vector &T)
{
	for (T_vector::iterator itr_T = T.begin(); itr_T < T.end(); itr_T++){
		Set_New_Edge_ID(E, &(*itr_T), 0, 0, 1);
		Set_New_Edge_ID(E, &(*itr_T), 1, 0, 2);
		Set_New_Edge_ID(E, &(*itr_T), 2, 1, 2);
	}

	return int(E.size());
}

//VӂIDݒ
void ContinuousAreaCartogramConstruction::Set_New_Edge_ID(E_vector &E, Triangle_Info *tmp_T,
							   const int E_Order, const int V_0, const int V_1)
{
	for (E_vector::iterator itr = E.begin(); itr < E.end(); itr++){
		if (((*tmp_T).V[V_0] == (*itr).V[0])&&((*tmp_T).V[V_1] == (*itr).V[1])){
			(*tmp_T).E[E_Order] = int(itr - E.begin());	//ӂIDݒ
			return;
		}
	}

	(*tmp_T).E[E_Order] = int(E.size());	//IDݒ
	E.push_back(Edge_Info((*tmp_T).V[V_0], (*tmp_T).V[V_1]));
}

void ContinuousAreaCartogramConstruction::calc_E_vector(co_vector &coord, co_vector &Edge_vec, E_vector &E)
{
	for (unsigned int i = 0; i < E.size(); i ++) Edge_vec[i] = coord[E[i].V[1]]-coord[E[i].V[0]];
}

double ContinuousAreaCartogramConstruction::Squared_Errors(T_vector &T)
{
	double sq_error = 0.0;

	for (T_vector::iterator itr = T.begin(); itr < T.end(); itr ++)
		sq_error += pow((*itr).Data - (*itr).Area, 2);

	return sq_error;
}

double ContinuousAreaCartogramConstruction::Error_Ratio(const double Total_Data, T_vector &T)
{
	double error = 0.0;

	for (T_vector::iterator itr = T.begin(); itr < T.end(); itr ++)
		error += fabs((*itr).Data - (*itr).Area);

	return error/Total_Data*100;
}

void ContinuousAreaCartogramConstruction::Renew_coord(const int N, co_vector &new_coord, double *Y)
{
	new_coord[0] = coord2D(0.0, 0.0);
	for (int i=0; i<N; i++) new_coord[i+1] = coord2D(Y[i], Y[i+N]);
}

void ContinuousAreaCartogramConstruction::Create_Sparse_Matrix(d_matrix &X, i_matrix &X_ID, int i, int j, double value)
{
	int j_ID;
	i_vector::iterator itr_X_ID;

	// X_ID[i]jT
	itr_X_ID = upper_bound(X_ID[i].begin(), X_ID[i].end(), j);
	j_ID = int(itr_X_ID - X_ID[i].begin());

	// X_ID[i]==jƂȂID݂ꍇClǉ
	if (int(X_ID[i].size())>0){
		if (j_ID > 0 && *(itr_X_ID-1) == j) X[i][j_ID-1] += value;
		else{
			X_ID[i].insert(itr_X_ID, j);
			X[i].insert(X[i].begin()+j_ID, value);
		}
	}

	// X_ID[i]==jƂȂID݂ȂꍇClj}
	else{
		X_ID[i].insert(itr_X_ID, j);
		X[i].insert(X[i].begin()+j_ID, value);
	}
}


void ContinuousAreaCartogramConstruction::AreaCarto_Expl_Matrix(d_matrix &X, i_matrix &X_ID, double *Y, co_vector &Edge_Vec, co_vector &coord,
			E_vector &E, const int X_row, const double myu, T_vector &T)
// 0Ԗڂ̒__ɐݒ肵Ă邱ƂOƂĂ
{
	int V_IDx, V_IDy, V_ID2x, V_ID2y, X_row_half=X_row / 2;
	double d_m4, x2_d4, xy_d4, y2_d4, LHS, RHS;
	coord2D ET_Vec[3];

	for (T_vector::iterator itr_T = T.begin(); itr_T < T.end(); itr_T ++){
		LHS = 0.5 / pow((*itr_T).Data, 2);

		//Δ̉Eӂ̈ꕔ(-(A+D)/D^2)
		RHS = - ((*itr_T).Area + (*itr_T).Data) / pow((*itr_T).Data, 2);

		for (int i=0; i<3; i++) ET_Vec[i] = Edge_Vec[(*itr_T).E[i]];

		if ((*itr_T).V[0] != 0){
			V_IDx = (*itr_T).V[0] - 1;
			V_IDy = V_IDx + X_row_half;

//			if ((*itr_T).V[0] != 0){
				V_ID2x = (*itr_T).V[0]-1;
				V_ID2y = V_ID2x + X_row_half;

				Create_Sparse_Matrix(X, X_ID, V_IDx, V_ID2x, + ET_Vec[2].y * ET_Vec[2].y * LHS);
				Create_Sparse_Matrix(X, X_ID, V_IDx, V_ID2y, - ET_Vec[2].x * ET_Vec[2].y * LHS);
				Create_Sparse_Matrix(X, X_ID, V_IDy, V_ID2x, - ET_Vec[2].y * ET_Vec[2].x * LHS);
				Create_Sparse_Matrix(X, X_ID, V_IDy, V_ID2y, + ET_Vec[2].x * ET_Vec[2].x * LHS);
//			}

			if ((*itr_T).V[1] != 0){
				V_ID2x = (*itr_T).V[1]-1;
				V_ID2y = V_ID2x + X_row_half;

				Create_Sparse_Matrix(X, X_ID, V_IDx, V_ID2x, - ET_Vec[1].y * ET_Vec[2].y * LHS);
				Create_Sparse_Matrix(X, X_ID, V_IDx, V_ID2y, + ET_Vec[1].x * ET_Vec[2].y * LHS);
				Create_Sparse_Matrix(X, X_ID, V_IDy, V_ID2x, + ET_Vec[1].y * ET_Vec[2].x * LHS);
				Create_Sparse_Matrix(X, X_ID, V_IDy, V_ID2y, - ET_Vec[1].x * ET_Vec[2].x * LHS);
			}

			if ((*itr_T).V[2] != 0){
				V_ID2x = (*itr_T).V[2]-1;
				V_ID2y = V_ID2x + X_row_half;

				Create_Sparse_Matrix(X, X_ID, V_IDx, V_ID2x, + ET_Vec[0].y * ET_Vec[2].y * LHS);
				Create_Sparse_Matrix(X, X_ID, V_IDx, V_ID2y, - ET_Vec[0].x * ET_Vec[2].y * LHS);
				Create_Sparse_Matrix(X, X_ID, V_IDy, V_ID2x, - ET_Vec[0].y * ET_Vec[2].x * LHS);
				Create_Sparse_Matrix(X, X_ID, V_IDy, V_ID2y, + ET_Vec[0].x * ET_Vec[2].x * LHS);
			}

			Y[V_IDx] += ET_Vec[2].y * RHS;
			Y[V_IDy] -= ET_Vec[2].x * RHS;
		}

		if ((*itr_T).V[1] != 0){
			V_IDx = (*itr_T).V[1] - 1;
			V_IDy = V_IDx + X_row_half;

			if ((*itr_T).V[0]!=0){
				V_ID2x = (*itr_T).V[0]-1;
				V_ID2y = V_ID2x + X_row_half;

				Create_Sparse_Matrix(X, X_ID, V_IDx, V_ID2x, - ET_Vec[2].y * ET_Vec[1].y * LHS);
				Create_Sparse_Matrix(X, X_ID, V_IDx, V_ID2y, + ET_Vec[2].x * ET_Vec[1].y * LHS);
				Create_Sparse_Matrix(X, X_ID, V_IDy, V_ID2x, + ET_Vec[2].y * ET_Vec[1].x * LHS);
				Create_Sparse_Matrix(X, X_ID, V_IDy, V_ID2y, - ET_Vec[2].x * ET_Vec[1].x * LHS);
			}

//			if ((*itr_T).V[1]!=0){
				V_ID2x = (*itr_T).V[1]-1;
				V_ID2y = V_ID2x + X_row_half;

				Create_Sparse_Matrix(X, X_ID, V_IDx, V_ID2x, + ET_Vec[1].y * ET_Vec[1].y * LHS);
				Create_Sparse_Matrix(X, X_ID, V_IDx, V_ID2y, - ET_Vec[1].x * ET_Vec[1].y * LHS);
				Create_Sparse_Matrix(X, X_ID, V_IDy, V_ID2x, - ET_Vec[1].y * ET_Vec[1].x * LHS);
				Create_Sparse_Matrix(X, X_ID, V_IDy, V_ID2y, + ET_Vec[1].x * ET_Vec[1].x * LHS);
//			}

			if ((*itr_T).V[2]!=0){
				V_ID2x = (*itr_T).V[2]-1;
				V_ID2y = V_ID2x + X_row_half;

				Create_Sparse_Matrix(X, X_ID, V_IDx, V_ID2x, - ET_Vec[0].y * ET_Vec[1].y * LHS);
				Create_Sparse_Matrix(X, X_ID, V_IDx, V_ID2y, + ET_Vec[0].x * ET_Vec[1].y * LHS);
				Create_Sparse_Matrix(X, X_ID, V_IDy, V_ID2x, + ET_Vec[0].y * ET_Vec[1].x * LHS);
				Create_Sparse_Matrix(X, X_ID, V_IDy, V_ID2y, - ET_Vec[0].x * ET_Vec[1].x * LHS);
			}

			Y[V_IDx] -= ET_Vec[1].y * RHS;
			Y[V_IDy] += ET_Vec[1].x * RHS;
		}

		if ((*itr_T).V[2] != 0){
			V_IDx = (*itr_T).V[2] - 1;
			V_IDy = V_IDx + X_row_half;

			if ((*itr_T).V[0]!=0){
				V_ID2x = (*itr_T).V[0]-1;
				V_ID2y = V_ID2x + X_row_half;

				Create_Sparse_Matrix(X, X_ID, V_IDx, V_ID2x, + ET_Vec[2].y * ET_Vec[0].y * LHS);
				Create_Sparse_Matrix(X, X_ID, V_IDx, V_ID2y, - ET_Vec[2].x * ET_Vec[0].y * LHS);
				Create_Sparse_Matrix(X, X_ID, V_IDy, V_ID2x, - ET_Vec[2].y * ET_Vec[0].x * LHS);
				Create_Sparse_Matrix(X, X_ID, V_IDy, V_ID2y, + ET_Vec[2].x * ET_Vec[0].x * LHS);
			}

			if ((*itr_T).V[1]!=0){
				V_ID2x = (*itr_T).V[1]-1;
				V_ID2y = V_ID2x + X_row_half;

				Create_Sparse_Matrix(X, X_ID, V_IDx, V_ID2x, - ET_Vec[1].y * ET_Vec[0].y * LHS);
				Create_Sparse_Matrix(X, X_ID, V_IDx, V_ID2y, + ET_Vec[1].x * ET_Vec[0].y * LHS);
				Create_Sparse_Matrix(X, X_ID, V_IDy, V_ID2x, + ET_Vec[1].y * ET_Vec[0].x * LHS);
				Create_Sparse_Matrix(X, X_ID, V_IDy, V_ID2y, - ET_Vec[1].x * ET_Vec[0].x * LHS);
			}

//			if ((*itr_T).V[2]!=0){
				V_ID2x = (*itr_T).V[2]-1;
				V_ID2y = V_ID2x + X_row_half;

				Create_Sparse_Matrix(X, X_ID, V_IDx, V_ID2x, + ET_Vec[0].y * ET_Vec[0].y * LHS);
				Create_Sparse_Matrix(X, X_ID, V_IDx, V_ID2y, - ET_Vec[0].x * ET_Vec[0].y * LHS);
				Create_Sparse_Matrix(X, X_ID, V_IDy, V_ID2x, - ET_Vec[0].y * ET_Vec[0].x * LHS);
				Create_Sparse_Matrix(X, X_ID, V_IDy, V_ID2y, + ET_Vec[0].x * ET_Vec[0].x * LHS);
//			}

			Y[V_IDx] += ET_Vec[0].y * RHS;
			Y[V_IDy] -= ET_Vec[0].x * RHS;
		}
	}

	for (E_vector::iterator itr_E = E.begin(); itr_E < E.end(); itr_E ++){
		d_m4 = 2 * pow(myu / norm(Edge_Vec[itr_E-E.begin()]), 2);
		x2_d4 = d_m4 * pow(Edge_Vec[itr_E-E.begin()].x, 2);
		xy_d4 = d_m4 * Edge_Vec[itr_E-E.begin()].x * Edge_Vec[itr_E-E.begin()].y;
		y2_d4 = d_m4 * pow(Edge_Vec[itr_E-E.begin()].y, 2);

		if ((*itr_E).V[0] != 0){
			V_IDx = (*itr_E).V[0] - 1;
			V_IDy = V_IDx + X_row_half;

//			if ((*itr_E).V[0] != 0){
				V_ID2x = (*itr_E).V[0] - 1;
				V_ID2y = V_ID2x + X_row_half;

				Create_Sparse_Matrix(X, X_ID, V_IDx, V_ID2x, +y2_d4);
				Create_Sparse_Matrix(X, X_ID, V_IDx, V_ID2y, -xy_d4);
				Create_Sparse_Matrix(X, X_ID, V_IDy, V_ID2x, -xy_d4);
				Create_Sparse_Matrix(X, X_ID, V_IDy, V_ID2y, +x2_d4);
//			}

			if ((*itr_E).V[1] != 0){
				V_ID2x = (*itr_E).V[1] - 1;
				V_ID2y = V_ID2x + X_row_half;

				Create_Sparse_Matrix(X, X_ID, V_IDx, V_ID2x, -y2_d4);
				Create_Sparse_Matrix(X, X_ID, V_IDx, V_ID2y, +xy_d4);
				Create_Sparse_Matrix(X, X_ID, V_IDy, V_ID2x, +xy_d4);
				Create_Sparse_Matrix(X, X_ID, V_IDy, V_ID2y, -x2_d4);
			}
			else{
				Y[V_IDx] += y2_d4 * coord[(*itr_E).V[1]].x - xy_d4 * coord[(*itr_E).V[1]].y;
				Y[V_IDy] -= xy_d4 * coord[(*itr_E).V[1]].x - x2_d4 * coord[(*itr_E).V[1]].y;
			}
		}

		if ((*itr_E).V[1] != 0){
			V_IDx = (*itr_E).V[1] - 1;
			V_IDy = V_IDx + X_row_half;

			if ((*itr_E).V[0] != 0){
				V_ID2x = (*itr_E).V[0] - 1;
				V_ID2y = V_ID2x + X_row_half;

				Create_Sparse_Matrix(X, X_ID, V_IDx, V_ID2x, -y2_d4);
				Create_Sparse_Matrix(X, X_ID, V_IDx, V_ID2y, +xy_d4);
				Create_Sparse_Matrix(X, X_ID, V_IDy, V_ID2x, +xy_d4);
				Create_Sparse_Matrix(X, X_ID, V_IDy, V_ID2y, -x2_d4);
			}
			else{
				Y[V_IDx] += y2_d4 * coord[(*itr_E).V[0]].x - xy_d4 * coord[(*itr_E).V[0]].y;
				Y[V_IDy] -= xy_d4 * coord[(*itr_E).V[0]].x - x2_d4 * coord[(*itr_E).V[0]].y;
			}

//			if ((*itr_E).V[1] != 0){
				V_ID2x = (*itr_E).V[1] - 1;
				V_ID2y = V_ID2x + X_row_half;

				Create_Sparse_Matrix(X, X_ID, V_IDx, V_ID2x, +y2_d4);
				Create_Sparse_Matrix(X, X_ID, V_IDx, V_ID2y, -xy_d4);
				Create_Sparse_Matrix(X, X_ID, V_IDy, V_ID2x, -xy_d4);
				Create_Sparse_Matrix(X, X_ID, V_IDy, V_ID2y, +x2_d4);
//			}
		}
	}
}