// Option.cpp : t@C
//

#include "stdafx.h"
#include "Plotter.h"
#include "Option.h"


// Option _CAO

IMPLEMENT_DYNAMIC(Option, CDialog)

Option::Option(CWnd* pParent /*=NULL*/)
: CDialog(Option::IDD, pParent){
	m_bData = FALSE;
}

Option::~Option(){}

void Option::DoDataExchange(CDataExchange* pDX){
	CDialog::DoDataExchange(pDX);
	DDX_Text(pDX, IDC_EDIT_UPPERLIMIT, m_UpperLimit);
	DDV_MinMaxInt(pDX, m_UpperLimit, 0, 100000000);
	DDX_Text(pDX, IDC_EDIT_LOWERLIMIT, m_LowerLimit);
	DDV_MinMaxInt(pDX, m_LowerLimit, 0, 10000000);
	DDX_Text(pDX, IDC_EDIT_TOP, m_LTop);
	DDX_Text(pDX, IDC_EDIT_BOTTOM, m_LBottom);
	DDX_Text(pDX, IDC_EDIT_RIGHT, m_LRight);
	DDX_Text(pDX, IDC_EDIT_LEFT, m_LLeft);
	DDX_Text(pDX, IDC_EDIT_COLORMAX, m_dMax);
	DDX_Text(pDX, IDC_EDIT_COLORMIN, m_dMin);
	DDX_Check(pDX, IDC_CHECK_NAME, m_bName);
	DDX_Text(pDX, IDC_EDIT_FONTSIZE, m_FontSize);
	DDV_MinMaxInt(pDX, m_FontSize, 1, 200);

	CString str("");
	str.Format(_T(":%d"),rect.top);
	GetDlgItem(IDC_STATIC_TOP)->SetWindowText(str);
	str.Format(_T(":%d"),rect.bottom);
	GetDlgItem(IDC_STATIC_BOTTOM)->SetWindowText(str);
	str.Format(_T(":%d"),rect.left);
	GetDlgItem(IDC_STATIC_LEFT)->SetWindowText(str);
	str.Format(_T("E:%d"),rect.right);
	GetDlgItem(IDC_STATIC_RIGHT)->SetWindowText(str);
	if(m_bData){
		str.Format(_T("%.4fȏ"),m_dDataMax);
		GetDlgItem(IDC_STATIC_MAXDATA)->SetWindowText(str);
		str.Format(_T("%.4fȉ"),m_dDataMin);
		GetDlgItem(IDC_STATIC_MINDATA)->SetWindowText(str);
	}else{
		str = _T("");
		GetDlgItem(IDC_STATIC_MAXDATA)->SetWindowText(str);
		GetDlgItem(IDC_STATIC_MINDATA)->SetWindowText(str);
	}
	DDX_Text(pDX, IDC_EDIT_POINTSIZE, m_PointSize);
	DDV_MinMaxInt(pDX, m_PointSize, 1, 100);
	DDX_Check(pDX, IDC_CHECK_BOUNDARY, m_bBoundary);
	DDX_Text(pDX, IDC_EDIT_BOUNDARYUNIT, m_BoundaryUnit);
	DDX_Text(pDX, IDC_EDIT_BOUNDARYSIZE, m_BoundarySize);
}


BEGIN_MESSAGE_MAP(Option, CDialog)
END_MESSAGE_MAP()

