// PlotterView.h : CPlotterView NX̃C^[tFCX
//
#include "Polygon.h"
#include "NewPolygon.h"
#include "ShiftPolygon.h"
#include "Option.h"
#include "GradientDialog.h"

#define PJ_LIB__
#include "projects.h"
#undef PL_LIB__

typedef	projPJ	(__cdecl *pF_pj_init)(int, char** );	// ֐|C^^
typedef	projXY  (__cdecl *pF_pj_fwd)(projLP, projPJ);	// ֐|C^^
typedef	void	(__cdecl *pF_pj_free)(projPJ);			// ֐|C^^
typedef	char*   (__cdecl *pF_pj_error)(int);	// ֐|C^^

#pragma once


class CPlotterView : public CView
{
protected: // VÂݍ쐬܂B
	CPlotterView();
	DECLARE_DYNCREATE(CPlotterView)

// 
public:
	CPlotterDoc* GetDocument() const;
	void CPlotterView::SetPlot(CDC *pDC,CCoord* pPos,int style);
protected:
	CSize m_sizeWindows;	//_W̊
	CSize m_sizePrintable;	//vg\Ș_W
	CSize m_sizeView;		//r[̊
	CPoint m_Offset;		//ʏ̌_̈ʒu
	CPoint m_WindowOrg;		//_W̒S̈ʒu
	int m_Stroke;			//_Wł̈ړ
	CRect m_rectClient;		//NCAg̈
	CPoint m_Pointer,m_Position;	//}EX̘_Wƕ\ʒu
	CString m_Title;		//r[̃^CgiGetTitle()ŎQƂ)
	CRect m_Visible;		//͈
	int m_LowerLimit,m_UpperLimit;
	CGradientDialog*  m_pColor;
	BOOL m_bColorDialogOn;
	CRect m_rectLegion;
	int m_FontSize;
	double m_DataRangeMax,m_DataRangeMin;
	double m_LegionRangeMax,m_LegionRangeMin;
	BOOL m_bName;
	int m_Mode;		//0:W[h1:xNg[h2:{[h3:[h
	int m_PointSize;
	//}C[֌W
	BOOL m_bLayer;
	//E֌W
	BOOL m_bBoundary;
	int m_BoundaryUnit,m_BoundarySize;
	//t@C
	CString VerticesPathName;
	CString PolygonPathName;

// 
public:
	void GetDefaultPaperSize();
	void GetCurrentPaperSize();
	void FocusOnCurrentPolygon();
	void FocusOnPolygon(int i);
	void FocusOnLastCoord();

// I[o[Ch
public:
	virtual void OnDraw(CDC* pDC);  // ̃r[`悷邽߂ɃI[o[Ch܂B
	virtual void OnPrepareDC(CDC* pDC, CPrintInfo* pInfo = NULL);
	virtual void OnInitialUpdate();
	virtual BOOL PreCreateWindow(CREATESTRUCT& cs);
	virtual BOOL DestroyWindow();

protected:
	virtual BOOL OnPreparePrinting(CPrintInfo* pInfo);
	virtual void OnBeginPrinting(CDC* pDC, CPrintInfo* pInfo);
	virtual void OnEndPrinting(CDC* pDC, CPrintInfo* pInfo);

// 
public:
	virtual ~CPlotterView();
#ifdef _DEBUG
	virtual void AssertValid() const;
	virtual void Dump(CDumpContext& dc) const;
#endif

protected:
	afx_msg void OnNextPoly();
	afx_msg void OnUpOrg();
	afx_msg void OnDownOrg();
	afx_msg void OnLeftOrg();
	afx_msg void OnRightOrg();
	afx_msg void OnZoomin();
	afx_msg void OnZoomout();
	afx_msg void OnRButtonDown(UINT nFlags, CPoint point);
	afx_msg void OnLButtonDown(UINT nFlags, CPoint point);
	afx_msg void OnMouseMove(UINT nFlags, CPoint point);
	afx_msg void OnPageSetup();
	afx_msg LONG OnNewColorRedraw(UINT wParam, LONG lParam);
	afx_msg LONG OnClosed(UINT wParam, LONG lParam);
	//afx_msg void OnPrinterSetup();

// ꂽAbZ[W蓖Ċ֐
protected:
	DECLARE_MESSAGE_MAP()

public:
	afx_msg void OnUpdateModeMenu(CCmdUI* pCmdUI);
	afx_msg void OnChangeMode(UINT nID);
	afx_msg void OnEditShiftMagnify();
	afx_msg void OnVertexRead();
	afx_msg void OnPolygonRead();
	afx_msg void OnVertexWriteRaw();
	afx_msg void OnVertexWrite();
	afx_msg void OnPolygonWrite();
	afx_msg void OnValidCheck();
	afx_msg void OnFitPaper();
	afx_msg void OnColorChange();
	afx_msg void OnDataRead();
	afx_msg void OnOption();
	afx_msg void OnReferenceRead();
	afx_msg void OnNocheckVerttexRead();
	afx_msg void OnNocheckPolygonRead();
	afx_msg void OnTranslate();
	afx_msg void OnLayerShow();
	afx_msg void OnLayerVertex();
	afx_msg void OnLayerPolygon();
	afx_msg void OnIdRename();
	afx_msg void OnGroupDelete();
	afx_msg void OnForcedsave();
	afx_msg void OnOpencarto();
	afx_msg void OnOpendeformed();
};

#ifndef _DEBUG  // PlotterView.cpp ̃fobO o[W
inline CPlotterDoc* CPlotterView::GetDocument() const
   { return reinterpret_cast<CPlotterDoc*>(m_pDocument); }
#endif

