////////////////////////////////////////////////////////////////////
//
//	CLASS	:	CColorButton
//	FILE	:	colorbtn.h
//	FUNCTION:	J[{^NX()
//	PRODUCER:	FUJIMON Chiaki
//				(chiaki_f@milk.freemail.ne.jp)
//	Copyright by FUJIMON Chiaki
//
////////////////////////////////////////////////////////////////////
/*

CColorButtonNXFJ[{^邽߂̃NXCu()łBCButtonNXhĂ̂ŁACButtonNX̃o͎gp\łB

1.colorbtn.h/colorbtn.cpp̂Q̃t@CvWFNgɒǉ(ǉclassviewCColorButton\)
2.gpt@Ccolorbtn.hCN[h
gp@
(1)CX^X
CColorButtongpNXŃCX^X𐶐(ϐ`)܂BʓIɂ̓wb_ɃoƂċLq̂ʂłBɃ_CAOł΁A_CAONX̃wb_ɃoϐƂĒ`܂B
(2)A^b`
J[{^͒ʏCButtonNX̕ϐł邽߁ACColorButtonƂėp邽߂ɂ͊֘AtKvƂȂ܂BTuNXƂ̂łAAutoLoadƂ֐Ŏ܂BAutoLoad֐̈ɂ́ARg[IDƐeEBhEKvłAʏ_CAO̒̃{^ɓKpꍇɂ́AeEBhEɂthis^΂悢łB
(3)J[ݒ(C)
LvV̐F(ʏ펞Ɩ)ƔwiF̐Fݒ肵܂Bݒ肵ȂĂfBtHgŐFĂ܂AfBtHgF͒ʏ̃{^ƕςȂ̂ŁAeݒ肵ĂB
*/
#include "stdafx.h"
#include "colorbtn.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

IMPLEMENT_DYNAMIC(CColorButton, CButton)

CColorButton::CColorButton() 
{
	// fBtHgJ[
	coltext = RGB(0, 0, 0);				// #0x00,0x00,0x00
	colbackground = RGB(192, 192, 192);	// #0xC0,0xC0,0xC0
	coldisabled = RGB(128, 128, 128);	// #0x80,0x80,0x80
} 

CColorButton::~CColorButton()
{
} 
void CColorButton::PreSubclassWindow()												// I[i[`
{
	CButton::PreSubclassWindow();
	ModifyStyle(0,BS_OWNERDRAW);
}
void CColorButton::SetBackGroundColor(const COLORREF color)
{
	colbackground = color;
	coltext = RGB(255-GetRValue(color),255-GetGValue(color),255-GetBValue(color));
}
// {^CColorButtonA^b`ɂ
BOOL CColorButton::AutoLoad(const UINT nID, CWnd* pParent)
{
	// _Ci~bNTuNX
	if (!SubclassDlgItem(nID, pParent))
		return false;

	return true;
} 

// I[i[`悷
void CColorButton::DrawItem(LPDRAWITEMSTRUCT lpDIS)
{
	CDC* pDC = CDC::FromHandle(lpDIS->hDC);
	CString strCaption;

	UINT nState = lpDIS->itemState; 
	CRect focusRect, btnRect;
	focusRect.CopyRect(&lpDIS->rcItem);
	btnRect.CopyRect(&lpDIS->rcItem); 

	// tH[JX`̈̍쐬
	focusRect.left += 4;
    focusRect.right -= 4;
    focusRect.top += 4;
    focusRect.bottom -= 4;

	// {^̃LvV擾
	GetWindowText(strCaption);

	// {^̕`(wiFAGbWALvV)
    DrawBkGround(pDC, btnRect, GetBackGroundColor()); 
  	DrawCaption(pDC, btnRect, GetTextColor(),strCaption);
	pDC->DrawEdge(btnRect,EDGE_RAISED,BF_RECT);

	// tH[JX𓾂ƂIĂƂ
	if (nState & ODS_FOCUS)
	{
		if (nState & ODS_SELECTED)
		{ 
    		DrawBkGround(pDC, btnRect, GetBackGroundColor());
  			DrawCaption(pDC, btnRect, GetTextColor(),strCaption);
			pDC->DrawEdge(btnRect,EDGE_SUNKEN,BF_RECT);
		}
		pDC->DrawFocusRect(focusRect);
	}// {^łƂ
	else if(nState & ODS_DISABLED)
	{
  		DrawCaption(pDC, btnRect, GetDisabledColor(), strCaption);
    }
} 

// wiF`
void CColorButton::DrawBkGround(CDC *pDC, CRect rect,const COLORREF color)
{ 
	CBrush brush(color);
	pDC->FillRect(rect, &brush);
}

// LvV`
void CColorButton::DrawCaption(CDC *pDC, CRect rect,const COLORREF color,const CString& str)
{
    COLORREF oldcolor = pDC->SetTextColor(color);
	pDC->SetBkMode(TRANSPARENT);
	pDC->DrawText(str,rect,DT_CENTER|DT_VCENTER|DT_SINGLELINE);
	pDC->SetTextColor(oldcolor);
}


		







