// ChildView.cpp : CChildView NX̎
//

#include "stdafx.h"
#include "CartogramMonitor2008.h"
#include "ChildView.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#endif

// CChildView

CChildView::CChildView(){
	m_bPolygon = m_bTriangle = m_bReversedTriangle = m_bIntersect = true;
}
CChildView::~CChildView(){}

BEGIN_MESSAGE_MAP(CChildView, CWnd)
	ON_WM_PAINT()
	ON_COMMAND(ID_CARTO_OPEN, &CChildView::OnCartoOpen)
	ON_COMMAND(ID_CARTO_RUN, &CChildView::OnCartoRun)
	ON_COMMAND(ID_CARTO_CONDITION, &CChildView::OnCartoCondition)
	ON_COMMAND(ID_CARTO_SAVE, &CChildView::OnCartoSave)
	ON_WM_TIMER()
	ON_UPDATE_COMMAND_UI(ID_CARTO_RUN,OnUpdateMenu)
	ON_UPDATE_COMMAND_UI(ID_CARTO_SAVE,OnUpdateMenu)
END_MESSAGE_MAP()

// CChildView bZ[W nh
BOOL CChildView::PreCreateWindow(CREATESTRUCT& cs) 
{
	if (!CWnd::PreCreateWindow(cs)) return FALSE;
	cs.dwExStyle |= WS_EX_CLIENTEDGE;
	cs.style &= ~WS_BORDER;
	cs.lpszClass = AfxRegisterWndClass(CS_HREDRAW|CS_VREDRAW|CS_DBLCLKS, 
		::LoadCursor(NULL, IDC_ARROW), reinterpret_cast<HBRUSH>(COLOR_WINDOW+1), NULL);
	return TRUE;
}
void CChildView::OnUpdateMenu(CCmdUI* pCmdUI){
	CString str = "vZJn";
	switch(pCmdUI->m_nID){
		case ID_CARTO_RUN:
			pCmdUI->Enable(CAC.m_bFileReady);
			if(CAC.m_bThread) str = (CAC.m_bSuspend) ? "vZĊJ" : "vZꎞ~"; 
			pCmdUI->SetText(str);
			break;
		case ID_CARTO_SAVE:
			pCmdUI->Enable(CAC.m_bFileReady);
			break;
	}
}

#define MAXPOS 1000
void CChildView::OnPaint() {
	CPaintDC dc(this);
	//wihԂ
	CRect m_rectClient;		//NCAg̈
	GetClientRect(m_rectClient);
	dc.FillSolidRect(&m_rectClient,RGB(255,255,255));

	CAC.m_cs.Lock();
	GetDimension2D(min,max,CAC.__coord);
	double width = max.x - min.x;
	double height= max.y - min.y;

	//}bCO[h̐ݒ
	CSize m_sizeWindows;	//_W̊
	CSize m_sizeView;		//r[̊
	m_sizeWindows.cx = 1000;m_sizeWindows.cy = -1000;	//_W̊
	m_sizeView.cx = m_sizeView.cy = 1000;				//r[̊
	dc.SetMapMode(MM_ANISOTROPIC);
	dc.SetWindowExt(m_sizeWindows);
	dc.SetViewportExt(m_sizeView);
	//ʂ̌_͒
	dc.SetViewportOrg(m_rectClient.right /2,m_rectClient.bottom/2);

	//`{
	double m = std::min(((double)m_rectClient.Width()) / width,((double)m_rectClient.Height()) / height);

	//`͈͂̒
	CPoint m_WindowOrg;		//_W̒S̈ʒu
	m_WindowOrg.x = (LONG)((max.x + min.x) / 2 * m);
	m_WindowOrg.y = (LONG)((max.y + min.y) / 2 * m);
	dc.SetWindowOrg(m_WindowOrg);
//
	HPEN hPen1 = ::CreatePen(PS_SOLID, 1, RGB(0,0,255) );		//
	HPEN hPen2 = ::CreatePen(PS_SOLID, 2, RGB(0,0,0) );			//
	HPEN hPenOld = (HPEN)::SelectObject(dc.m_hDC,(HGDIOBJ)hPen2);

	LOGBRUSH    lBr;
	lBr.lbStyle=BS_SOLID;
	lBr.lbColor=RGB(255,225,225);							//
	lBr.lbHatch=0L;
	HBRUSH hBrush1 = CreateBrushIndirect(&lBr);
	lBr.lbStyle=BS_SOLID;
	lBr.lbColor=RGB(128,128,0);								//
	lBr.lbHatch=0L;
	HBRUSH hBrush2 = CreateBrushIndirect(&lBr);
	HBRUSH hOldBrush = (HBRUSH)::SelectObject(dc.m_hDC,hBrush1);

	int i;
	POINT point[MAXPOS];
	if(m_bPolygon){
		P_vector::iterator itr_P;
		i_vector::iterator itr_i;
		for(itr_P = CAC.__P.begin(); itr_P < CAC.__P.end(); itr_P ++){
			i = 0;
			for (itr_i = (*itr_P).V_ID.begin(); itr_i < (*itr_P).V_ID.end(); itr_i ++){
				point[i].x = (LONG)(CAC.__coord[*itr_i].x * m);
				point[i].y = (LONG)(CAC.__coord[*itr_i].y * m);
				i++;
			}
			::Polygon(dc.m_hDC,point,i);
		}
	}
	SelectObject(dc.m_hDC, hPen1);
	//OpԂ̕\
	T_vector::iterator itr_Tri;
	if(m_bTriangle){
		for(itr_Tri = CAC.__T.begin(); itr_Tri < CAC.__T.end(); itr_Tri++){						//eOp`ɂ
			for (i = 0; i < 3; i ++){
				point[i].x = (LONG)(CAC.__coord[(*itr_Tri).V[i]].x * m);
				point[i].y = (LONG)(CAC.__coord[(*itr_Tri).V[i]].y * m);
			}
			point[3].x = (LONG)(CAC.__coord[(*itr_Tri).V[0]].x * m);
			point[3].y = (LONG)(CAC.__coord[(*itr_Tri).V[0]].y * m);
			::Polyline(dc.m_hDC,point,4);
		}
	}
	//]Op̕\
	/*
	if(m_bReversedTriangle){
		::SelectObject(dc.m_hDC,hBrush2);
		for (itr_Tri = CAC.__T.begin(); itr_Tri < CAC.__T.end(); itr_Tri++){
			if (((*itr_Tri).Data * (*itr_Tri).Area) < 0){
				for (i = 0; i < 3; i ++){
					point[i].x = (LONG)(CAC.__coord[(*itr_Tri).V[i]].x * m);
					point[i].y = (LONG)(CAC.__coord[(*itr_Tri).V[i]].y * m);
				}
				point[3].x = (LONG)(CAC.__coord[(*itr_Tri).V[0]].x * m);
				point[3].y = (LONG)(CAC.__coord[(*itr_Tri).V[0]].y * m);
				::Polygon(dc.m_hDC,point,4);
			}
		}
	}
	*/
	//_̕\
	//if(m_bIntersect){
	//}
	CAC.m_bUpdate = false;
	CAC.m_cs.Unlock();
	SelectObject(dc.m_hDC, hOldBrush);
	SelectObject(dc.m_hDC, hPenOld);
	DeleteObject(hBrush1);
	DeleteObject(hBrush2);
	DeleteObject(hPen1);
	DeleteObject(hPen2);
}

void CChildView::OnCartoOpen()
{
	CFolderDialog Dlg;
	if(Dlg.DoModal() == IDOK){
		Folder = Dlg.GetFolderPath();
		if(!CAC.Read((LPCSTR)Folder)){
			MessageBox(_T("Wt@CE|St@CEf[^t@C̉ꂩɖ肪܂B"),
				_T("JgO̓ǂݍ݂Ɏs"),MB_ICONERROR | MB_OK);
			return;
		}
		AfxGetMainWnd()->SetWindowText(Folder);
		Invalidate(FALSE);
	}
}
void CChildView::OnCartoSave(){
	CAC.Write((LPCSTR)Folder);
}
void CChildView::OnCartoRun(){
	if(!CAC.m_bThread){
		CAC.Start();
		return;
	}else{
		if(CAC.m_bSuspend)CAC.Resume();
		else CAC.Stop();
	}
}

void CChildView::OnCartoCondition(){
	CConditionDlg Dlg;
	Dlg.m_desired_error = CAC.Error_desired;
	Dlg.m_init_miu = CAC.myu;
	Dlg.m_bPolygon = m_bPolygon;
	Dlg.m_bTriangle = m_bTriangle;
	Dlg.m_bReversed = m_bReversedTriangle;
	Dlg.m_bIntersect = m_bIntersect;
	if(Dlg.DoModal() == IDOK){
		CAC.Error_desired = Dlg.m_desired_error;
		CAC.myu = Dlg.m_init_miu;
		m_bPolygon = Dlg.m_bPolygon != 0 ? true : false;
		m_bTriangle = Dlg.m_bTriangle != 0 ? true : false;
		m_bReversedTriangle = Dlg.m_bReversed != 0 ? true : false;
		m_bIntersect = Dlg.m_bIntersect != 0 ? true : false;
	}
	Invalidate();
}

/// ^C}[֌W
void CChildView::OnTimer(UINT_PTR nIDEvent){
	if(CAC.m_bUpdate) Invalidate(true);
	CWnd::OnTimer(nIDEvent);
}
BOOL CChildView::Create(LPCTSTR lpszClassName, LPCTSTR lpszWindowName, DWORD dwStyle, const RECT& rect, CWnd* pParentWnd, UINT nID, CCreateContext* pContext){
	BOOL res = CWnd::Create(lpszClassName, lpszWindowName, dwStyle, rect, pParentWnd, nID, pContext);
	m_nTimer = SetTimer(1,30,NULL);
	return res;
}
BOOL CChildView::DestroyWindow(){
	KillTimer(m_nTimer);
	return CWnd::DestroyWindow();
}

