#include "stdafx.h"

UINT mainLoop(LPVOID pParam){
	ContinuousAreaCartogram* p_this =(ContinuousAreaCartogram*)pParam;
	while(WAIT_TIMEOUT == ::WaitForSingleObject(p_this->m_pKill->m_hObject,0))
	{
		p_this->TIN.TIN_Make_in_P(p_this->T, p_this->coord, p_this->P);
			p_this->m_cs.Lock();	//enter critical_section
				p_this->__T = p_this->T;p_this->__coord=p_this->coord;
				p_this->m_bUpdate = true;
			p_this->m_cs.Unlock();	//leave critical_section
		p_this->Error = p_this->Construction.TIN_Area(p_this->Error_desired, &(p_this->myu), p_this->coord, p_this->T, p_this->E_Outer);
			p_this->m_cs.Lock();
				p_this->__coord=p_this->coord;
				p_this->m_bUpdate = true;
			p_this->m_cs.Unlock();
		if(p_this->Error < p_this->Error_desired) break;
	}
	p_this->m_bThread = FALSE;
	::AfxEndThread(0,TRUE);
	return 0;
}
bool ContinuousAreaCartogram::Start(){
	if(m_pThread != NULL) return false;
	m_pThread = ::AfxBeginThread(mainLoop,(LPVOID)this,0,0,CREATE_SUSPENDED,NULL);
	m_pThread->m_bAutoDelete = FALSE;
	m_pThread->ResumeThread();
	m_bThread = TRUE;
	return true;
}
bool ContinuousAreaCartogram::Stop(){
	if(!m_bThread) return false;
	m_cs.Lock();
		m_pThread->SuspendThread();
		m_bSuspend = TRUE;
	m_cs.Unlock();
	return true;
}
bool ContinuousAreaCartogram::Resume(){
	if(!m_bThread) return false;
	m_cs.Lock();
		m_pThread->ResumeThread();
		m_bSuspend = FALSE;
	m_cs.Unlock();
	return true;
}
bool ContinuousAreaCartogram::Kill(){
	if(!m_bThread) return false;
	m_pKill->SetEvent();
	::WaitForSingleObject(m_pThread,INFINITE);
	return true;
}
bool ContinuousAreaCartogram::Read(LPCSTR pFolder){
	if(m_bFileReady){
		coord.clear();__coord.clear();
		P.clear();__P.clear();
		V.clear();__V.clear();
		E_Outer.clear();__E_Outer.clear();
		T.clear();__T.clear();
	}
	if (!IO.Input_Data((char *)pFolder, (char *)pFolder, coord, P, V)) return false;
	Util.Set_OuterEdge_ID(P, E_Outer);
	__P = P;__V = V;__coord = coord;__E_Outer = E_Outer;
	m_bFileReady = m_bUpdate = true;
	return true;
}
bool ContinuousAreaCartogram::Write(LPCSTR pFolder){
	Util.Set_Origin(V, coord);
	IO.Output_P_V((char *)pFolder, coord, P, V);
	return true;
}