#include "stdafx.h"

void TINConstruction::TIN_Make_in_P(T_vector &T, co_vector &coord, P_vector &P)
{
	int N_T_first;
	i_vector tmp_P_V, Added_V_ID;
	T_vector::iterator itr_T;
	ContinuousAreaCartogramUtility Util;

	//Op`f[^̏
	T.clear();

	for (P_vector::iterator itr_P = P.begin(); itr_P < P.end(); itr_P ++){
		(*itr_P).Area = 0.0;
		N_T_first = int(T.size());

		tmp_P_V.resize((*itr_P).V_ID.size());
		std::copy((*itr_P).V_ID.begin(), (*itr_P).V_ID.end(), tmp_P_V.begin());

		// PolygonɎOpԂ쐬
		Tin_Make_wo_Centroid(T, tmp_P_V, coord);
		Adjust_TIN_Flip(N_T_first, T, coord);

		Steiner(N_T_first, coord, T, Added_V_ID);
		if (Added_V_ID.size()!=0){
			Adjust_TIN_Flip(N_T_first, T, coord);

			for (int i=0; i<3; i++){
				Laplacian_Smoothing(N_T_first, T, coord, Added_V_ID);
				Adjust_TIN_Flip(N_T_first, T, coord);
			}
		}

		//Op`̖ʐ(t)vZ
		for (itr_T = T.begin() + N_T_first; itr_T < T.end(); itr_T ++){
			(*itr_T).Area = Util.calc_tri_area_w_sign(coord, *itr_T);
			(*itr_T).P_ID = (*itr_P).ID;
			(*itr_P).Area += fabs((*itr_T).Area);
		}

		//|S̖x(f[^/ʐ)vZ
		(*itr_P).Density = (*itr_P).Data / (*itr_P).Area;

		//Op`ɖʐψf[^蓖Ă
		for (itr_T = T.begin() + N_T_first; itr_T < T.end(); itr_T ++)
			(*itr_T).Data = (*itr_P).Density * (*itr_T).Area;

		tmp_P_V.clear();
		Added_V_ID.clear();
	}

	cout<<"OpԐݒ芮"<<endl;
}

//ӂLOp`
bool TINConstruction::Tri_Share_Edge(const int V_ID_1, const int V_ID_2, const int T_ID, const int min_T_ID,
				const int max_T_ID, T_vector &T, int *found_T_ID, int *not_shared_V_ID)
{
	int i, j, k, m, V_ID_s, V_ID_l;

	V_ID_s = min(V_ID_1, V_ID_2);
	V_ID_l = max(V_ID_1, V_ID_2);

	for (i = min_T_ID; i < max_T_ID; i++){
		if (T_ID!=i){//قȂOp`T
			for (j=0; j<2; j++){
				if (V_ID_s==T[i].V[j]){
					for (k=j+1; k<3; k++){
						if (V_ID_l==T[i].V[k]){
							m = 0;
							while ((m==j)||(m==k)) ++ m;
							*not_shared_V_ID = T[i].V[m];
							*found_T_ID = i;
							return true;
						}
					}
				}
			}
		}
	}
	return false;
}

//ŏpőƂȂ悤FlippĎOpԂ蒼
void TINConstruction::Adjust_TIN_Flip(const int N_T_first, T_vector &T, co_vector &coord)
{
	bool Flipped;
	int i, j, found_T_ID, not_shared_V_ID, N_T, tmp_V[4];
	ContinuousAreaCartogramUtility Util;

	N_T = int(T.size());

	do{
		Flipped = false;
		for (i = N_T_first; i < N_T; i ++){
			for (j=0; j<3; j++){
				tmp_V[0] = T[i].V[j];
				tmp_V[1] = T[i].V[Util.ID_check(j+1, 3)];
				tmp_V[2] = T[i].V[Util.ID_check(j+2, 3)];
				if (Tri_Share_Edge(tmp_V[0], tmp_V[2], i, N_T_first, N_T, T, &found_T_ID, &not_shared_V_ID)){
					tmp_V[3] = not_shared_V_ID;

					if (Flip(tmp_V, coord, T)){
						T.erase(T.begin()+max(i,found_T_ID));
						T.erase(T.begin()+min(i,found_T_ID));
						Flipped = true;
					}
				}
			}
		}
	} while (Flipped);
}

//----O IDԍ͎v
void TINConstruction::Tin_Make_wo_Centroid(T_vector &T, i_vector &tmp_P_V, co_vector &coord)
{
	bool hantei;
	int i, tmp_V[3], tmp_O[3], N_V = int(tmp_P_V.size());
	d_vector e_d(N_V), s_v(N_V), c_v(N_V);
	co_vector Edge_Vec(N_V);
	std::vector<ID_Value> V_pos;
	vector<ID_Value>::iterator itr;
	ID_Value tmp_ID;
	ContinuousAreaCartogramUtility Util;

	for (i=0; i<N_V; i++) Util.calc_edge_length(i, tmp_P_V, N_V, coord, Edge_Vec, e_d);
	for (i=0; i<N_V; i++) Util.calc_angle(i, N_V, Edge_Vec, e_d, c_v, s_v);

	while (N_V>3){
		//px180ȉ𒊏o
		for (i=0; i<N_V; i++){
			if (s_v[i] > 0.0){
				tmp_ID.ID = i;tmp_ID.Value = c_v[i];
				V_pos.push_back(tmp_ID);
			}
		}
		sort(V_pos.begin(), V_pos.end(), large_ID_Value);

		//Ȋpx珇ɎOp`@A̓_ɂƂ͎̌T
		for (itr  = V_pos.begin(); itr < V_pos.end(); itr++){
			for (i=0; i<3; i++){
				tmp_O[i] = Util.ID_check((*itr).ID - 1 + i, N_V);
				tmp_V[i] = tmp_P_V[tmp_O[i]];
			}

			//ɓ_ȂTCΎOp`钸_
			hantei = true;
			for (i=0; i<N_V; i++){
				if ((s_v[i] <= 0.0)&&(tmp_P_V[i] != tmp_V[0])&&(tmp_P_V[i] != tmp_V[2])){
					if (Util.Point_In_ThreePoints(coord[tmp_P_V[i]], coord[tmp_V[0]], coord[tmp_V[1]], coord[tmp_V[2]])){
						hantei = false;
						break;
					}
				}
			}

			if (hantei){
				//Op`t@C̏o
				T.push_back(Triangle_Info(tmp_V));
				V_pos.clear();

				//tmp_O[0] ̕Ӓ𒸓_tmp_V[0] tmp_V[2]Ԃ̕ӒɍXV
				e_d[tmp_O[0]] = sqrt_norm(coord[tmp_V[2]]-coord[tmp_V[0]]);

				//tmp_O[0]Etmp_O[2] ̒pcosEsinXV
				Util.calc_sincos_ijk(tmp_P_V[Util.ID_check(tmp_O[0]-1, N_V)], tmp_V[0], tmp_V[2], coord, &s_v[tmp_O[0]], &c_v[tmp_O[0]]);
				Util.calc_sincos_ijk(tmp_V[0], tmp_V[2], tmp_P_V[Util.ID_check(tmp_O[2]+1, N_V)], coord, &s_v[tmp_O[2]], &c_v[tmp_O[2]]);

				//_EcosEsinEӒ̃Xg
				tmp_P_V.erase(tmp_P_V.begin() + tmp_O[1]);
				e_d.erase(e_d.begin() + tmp_O[1]);
				s_v.erase(s_v.begin() + tmp_O[1]);
				c_v.erase(c_v.begin() + tmp_O[1]);
				-- N_V;

				break;
			}
		}
	}

	//Op`̃m[hԍL^
	T.push_back(Triangle_Info(tmp_P_V[0], tmp_P_V[1], tmp_P_V[2]));
}

//tbvs
bool TINConstruction::Flip(int *P_V, co_vector &coord, T_vector &T)
{
	double radius_sq;
	coord2D circle;
	ContinuousAreaCartogramUtility Util;

	//̎Op`lӌ`ʂǂ聩Ίp
	if (Util.intersect(P_V[0], P_V[2], P_V[1], P_V[3], coord)){
		//P_V[0] P_V[1] P_V[2]̊Oډ~߂
		Circumcircle(P_V, &circle, &radius_sq, coord);

		//Oډ~P_V[3]ꍇ
		if (Point_in_Circle(P_V[3], radius_sq, circle, coord)){
			T.push_back(Triangle_Info(P_V[0], P_V[1], P_V[3]));
			T.push_back(Triangle_Info(P_V[1], P_V[2], P_V[3]));
			return true;
		}
	}
	return false;
}

//Op`̊Oډ~̒SWƔa߂
void TINConstruction::Circumcircle(int *Point_ID, coord2D *center, double *radius_sq, co_vector &coord)
{
	int i;
	double tmp_U_norm[2], tmp_L;
	coord2D Edge_Vec[2];

	for (i=0; i<2; i++) Edge_Vec[i] = coord[Point_ID[i+1]] - coord[Point_ID[0]];

	tmp_L = (Edge_Vec[0].y * Edge_Vec[1].x - Edge_Vec[0].x * Edge_Vec[1].y) * 2;
	for (i=0; i<2; i++) tmp_U_norm[i] = norm(Edge_Vec[i]);

	*center = coord2D((-tmp_U_norm[0] * Edge_Vec[1].y + tmp_U_norm[1] * Edge_Vec[0].y) / tmp_L,
						(tmp_U_norm[0] * Edge_Vec[1].x - tmp_U_norm[1] * Edge_Vec[0].x) / tmp_L);
	*radius_sq = norm(*center);
	*center = coord[Point_ID[0]] + *center;
}

//Oډ~Point_IDȂT
bool TINConstruction::Point_in_Circle(const int Point_ID, const double radius_sq, coord2D circle, co_vector &coord)
{
	if (norm(coord[Point_ID]-circle) / radius_sq < 1-EPS) return true; //ۂߌ덷΍
	else return false;
}

void TINConstruction::Steiner(const int N_T_first, co_vector &coord, T_vector &T, i_vector &Added_V_ID)
{
	bool Add;
	int i, j, N_tmp_V = 0;
	double tmp_radius, dist, length;
	const double alpha = 0.65, beta = 0.5;
	coord2D coord_center;
	co_vector tmp_coord, add_coord;
	i_map tmp_V;
	pair<i_map::iterator, bool> res;
	T_vector::iterator itr_T, itr_T_First;

	itr_T_First = T.begin() + N_T_first;

	//Op`̒_IDi[
	for (itr_T = itr_T_First; itr_T < T.end(); itr_T ++){
		for (j=0; j<3; j++){
			res = tmp_V.insert(pair<int, int>((*itr_T).V[j], N_tmp_V));
			if (res.second){
				tmp_coord.push_back(coord[(*itr_T).V[j]]);
				++ N_tmp_V;
			}
		}
	}

	vector<bool> Edge_list(N_tmp_V * N_tmp_V, false);
	i_vector count_Edge(N_tmp_V, 0);
	d_vector radius(N_tmp_V);
	d_vector Sum_Edge_length(N_tmp_V, 0.0);

	//Op`̕ӂ̏i[
	for (itr_T = itr_T_First; itr_T < T.end(); itr_T ++){
		for (i=0; i<2; i++){
			for (j=i+1; j<3; j++){
				if (tmp_V[(*itr_T).V[i]] < tmp_V[(*itr_T).V[j]])
					Edge_list[tmp_V[(*itr_T).V[i]] + tmp_V[(*itr_T).V[j]] * N_tmp_V] = true;
				else
					Edge_list[tmp_V[(*itr_T).V[j]] + tmp_V[(*itr_T).V[i]] * N_tmp_V] = true;
			}
		}
	}

	//_ɂȂӂ̕ϒvZ
	for (i=0; i<N_tmp_V-1; i++){
		for (j=i+1; j<N_tmp_V; j++){
			if (Edge_list[i+j*N_tmp_V]){
				length = sqrt_norm(tmp_coord[i]-tmp_coord[j]);

				++ count_Edge[i];
				++ count_Edge[j];

				Sum_Edge_length[i] += length;
				Sum_Edge_length[j] += length;
			}
		}
	}

	for (i=0; i<N_tmp_V; i++) radius[i] = Sum_Edge_length[i] / count_Edge[i];

	//Steiner_̒ǉ쐬@e_radiusȏ㗣邱
	for (i = N_T_first; i < int(T.size()); i ++){
		tmp_radius = (radius[tmp_V[T[i].V[0]]]+radius[tmp_V[T[i].V[1]]]+radius[tmp_V[T[i].V[2]]])/3;

		coord_center = (coord[T[i].V[0]]+coord[T[i].V[1]]+coord[T[i].V[2]])/3;
		dist = min(sqrt_norm(coord[T[i].V[0]]-coord_center),
					min(sqrt_norm(coord[T[i].V[1]]-coord_center), sqrt_norm(coord[T[i].V[2]]-coord_center)));

		if (dist > tmp_radius * alpha){
			Add = true;
			for (j=0; j<int(add_coord.size()); j++){
				if (sqrt_norm(add_coord[j] - coord_center) < tmp_radius * beta){
					Add = false;
					break;
				}
			}

			if (Add){
				T.push_back(Triangle_Info(T[i].V[0], T[i].V[2], int(coord.size())));
				T.push_back(Triangle_Info(T[i].V[1], T[i].V[2], int(coord.size())));

				T[i].V[2] = int(coord.size());
				Added_V_ID.push_back(int(coord.size()));

				coord.push_back(coord_center);
				add_coord.push_back(coord_center);
			}
		}
	}
}

void TINConstruction::Laplacian_Smoothing(const int N_T_First, T_vector &T, co_vector &coord, i_vector &Added_V_ID)
{
	bool Inside, Overturn;
	double Tri_Area, Total_Area;
	coord2D coord_COM, coord_Tri;
	T_vector::iterator itr_T, itr_T2, itr_T_First = T.begin() + N_T_First;
	ContinuousAreaCartogramUtility Util;

	//ǉꂽ_Ɋւ
	for (i_vector::iterator itr_i = Added_V_ID.begin(); itr_i < Added_V_ID.end(); itr_i ++){
		coord_COM = coord2D(0.0, 0.0);
		Total_Area = 0.0;

		//_𒸓_Ƃ鑽p`̏dS߂
		for (itr_T = itr_T_First; itr_T < T.end(); itr_T ++){
			for (int k=0; k<3; k++){
				if ( (*itr_i) == (*itr_T).V[k]){
					coord_Tri = (coord[(*itr_T).V[0]] + coord[(*itr_T).V[1]] + coord[(*itr_T).V[2]])/3;
					Tri_Area = fabs(Util.calc_tri_area_w_sign(coord, (*itr_T)));

					coord_COM = coord_COM + coord_Tri * Tri_Area;
					Total_Area += Tri_Area;
					break;
				}
			}
		}
		
		if (Total_Area == 0.0) printf("Error");
		coord_COM = coord_COM / Total_Area;

		Inside = false;
		Overturn = false;

		//p`̏dSp`Ɋ܂܂ĂƂ
		for (itr_T = itr_T_First; itr_T < T.end(); itr_T ++){
			if (Util.Point_In_ThreePoints(coord_COM, coord[(*itr_T).V[0]], coord[(*itr_T).V[1]], coord[(*itr_T).V[2]])){
				Inside = true;

				for (itr_T2 = itr_T_First; itr_T2 < T.end(); itr_T2 ++){
					//_̈ړɂOp`̔]̗LmF
					if (Overturn_Triangle(*itr_i, coord_COM, *itr_T2, coord)){
						Overturn = true;
						break;
					}
				}
				break;
			}
		}

		if ((!Overturn)&&(Inside)) coord[*itr_i] = coord_COM;
	}
}

//Target̍Wcoord_COMɕύXOp`]邩𔻒
bool TINConstruction::Overturn_Triangle(const int Target, coord2D coord_COM, Triangle_Info T, co_vector &coord)
{
	bool included = false;
	coord2D Edge_Vec[4], co_Target_p, co_Target_m;
	ContinuousAreaCartogramUtility Util;

	for (int i=0; i<3; i++){
		if (T.V[i] == Target){
			co_Target_p = coord[T.V[Util.ID_check(i+1, 3)]];
			co_Target_m = coord[T.V[Util.ID_check(i-1, 3)]];

			included = true;
			break;
		}
	}

	if (!included) return false;		

	Edge_Vec[0] = co_Target_p - coord[Target];
	Edge_Vec[1] = co_Target_m - coord[Target];

	Edge_Vec[2] = co_Target_p - coord_COM;
	Edge_Vec[3] = co_Target_m - coord_COM;

	//sin̕ωȂƂ]Ȃ
	if ((Edge_Vec[0].x * Edge_Vec[1].y - Edge_Vec[0].y * Edge_Vec[1].x)
		*(Edge_Vec[2].x * Edge_Vec[3].y - Edge_Vec[2].y * Edge_Vec[3].x) > 0.0)
		return false;

	return true;
}