#if !defined(AFX_GRADIENTDIALOG_H__A17B4288_88C8_4A78_B13B_3F5B438ECF2F__INCLUDED_)
#define AFX_GRADIENTDIALOG_H__A17B4288_88C8_4A78_B13B_3F5B438ECF2F__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000
// GradientDialog.h : wb_[ t@C
/*

#define IDD_DIALOG_GRADIENT             35100
#define IDC_GRADIENT                    35101
#define IDC_BUTTON_ADD                  35102
#define IDC_BUTTON_ADD_COLOR            35103
#define IDC_BUTTON_DELETE               35104
#define IDC_BUTTON_DELETE_COLOR         35105
#define IDC_BUTTON_MODE1                35106
#define IDC_BUTTON_MODE2                35107
#define IDC_BUTTON_MODE3                35108
#define IDC_COMBO_MODE                  35109
#define ID_COLOR_OK                     35110
#define ID_COLOR_CANCEL                 35111

#define IDC_STATIC_POS_ADD              35112
#define IDC_STATIC_POS_DELETE           35113
#define IDC_STATIC_MIN                  35114
#define IDC_STATIC_MAX                  35115

#define IDC_EDIT_ADD                    35120
#define IDC_EDIT_DELETE                 35121
#define IDC_EDIT_QUANT                  35122
#define IDC_CHECK_QUANT                 35123
#define IDC_CHECK_HANREI                35124

#define IDC_STATIC_COLOR                35130
#define IDC_STATIC_ADD                  35131
#define IDC_STATIC_DELETE               35132
#define IDC_STATIC_MODE                 35133
#define IDC_STATIC_INIT                 35134
#define IDC_STATIC_HANREI               35135
#define IDC_STATIC_INIT                 35136
*/

#include "colorbtn.h"
#include "GradientCtrl.h"
#include "resource.h"
//#include "WhiteWindow.h"

#define WM_COLOR_CHANGE		WM_USER  + 5
#define WM_COLOR_CLOSED		WM_USER  + 6

class CWhiteWindow;
/////////////////////////////////////////////////////////////////////////////
// CGradientDialog _CAO

class CGradientDialog : public CDialog
{
// RXgNV
public:
	bool DrawChart(CDC* pDC,CRect* pRect,LPCTSTR pTitle = NULL,int Font = 40,int FontMesure = 16,int arm = 100);
	double m_minData,m_maxData,m_middleData;
	double m_Stufe[11];
	bool SetDataRange(double min,double max);
	BOOL ModelessCreate();
	COLORREF GetRandomColor();
	COLORREF GetRandomColorLight();
	COLORREF TranslateToColor(double Data);
	COLORREF TranslateToColor(float Data);
	CGradientDialog(CWnd* pParent = NULL);   // W̃RXgN^
	CGradientDialog(CView* pView);   // [_pRXgN^
	void OnHorizontal();
	void OnVertical();
	void OnRightTop();
	void OnLeftBottom();
	void OnShowtooltips();
// _CAO f[^
	//{{AFX_DATA(CGradientDialog)
	enum { IDD = IDD_DIALOG_GRADIENT };
	CComboBox	m_Mode;
	float	m_AddPos;
	float	m_DeletePos;
	UINT	m_NumberOfQuant;
	BOOL	m_EnableQuant;
	BOOL	m_EnableSample;
	//}}AFX_DATA

	BOOL	m_bShowToolTips;
	BOOL	m_UseBackground;


// I[o[Ch
	// ClassWizard ͉z֐̃I[o[Ch𐶐܂B
	//{{AFX_VIRTUAL(CGradientDialog)
	public:
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV T|[g
	//}}AFX_VIRTUAL

// Cve[V
protected:
	CWhiteWindow* m_pWin;
	CView* m_pView;
	CColorButton ButtonAddColor,ButtonDeleteColor;
	CGradientCtrl m_wndGradientCtrl;
	COLORREF m_AddColor,m_DeleteColor,m_BGColor;
	void SetControls();
	//{{AFX_MSG(CGradientDialog)
	afx_msg void OnButtonAdd();
	afx_msg void OnButtonAddColor();
	afx_msg void OnButtonDelete();
	afx_msg void OnButtonDeleteColor();
	afx_msg void OnNotifyChangeSelPeg(NMHDR * pNotifyStruct, LRESULT *result);
	afx_msg void OnNotifyPegMove(NMHDR * pNotifyStruct, LRESULT *result);
	afx_msg void OnNotifyPegMoved(NMHDR * pNotifyStruct, LRESULT *result);
	afx_msg void OnNotifyPegRemoved(NMHDR * pNotifyStruct, LRESULT *result);
	afx_msg void OnNotifyDoubleClickCreatePeg(NMHDR * pNotifyStruct, LRESULT *result);
	afx_msg void OnNotifyEditPeg(NMHDR * pNotifyStruct, LRESULT *result);
	virtual BOOL OnInitDialog();
	afx_msg void OnCheckQuant();
	afx_msg void OnChangeEditQuant();
	afx_msg void OnChangeEditDelete();
	afx_msg void OnSelchangeComboMode();
	afx_msg void OnCheckHanrei();
	afx_msg void OnButtonMode1();
	afx_msg void OnButtonMode2();
	afx_msg void OnButtonMode3();
	virtual void OnModelessOK();
	virtual void OnModelessCancel();
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()

};

//{{AFX_INSERT_LOCATION}}
// Microsoft Visual C++ ͑Os̒Oɒǉ̐錾}܂B

#endif // !defined(AFX_GRADIENTDIALOG_H__A17B4288_88C8_4A78_B13B_3F5B438ECF2F__INCLUDED_)
