////////////////////////////////////////////////////////////////////
//
//	CLASS	:	CColorButton
//	FILE	:	colorbtn.h
//	FUNCTION:	J[{^NX(`)
//	PRODUCER:	FUJIMON Chiaki
//				(chiaki_f@milk.freemail.ne.jp)
//	Copyright by FUJIMON Chiaki
//
////////////////////////////////////////////////////////////////////

#ifndef ___CCOLORBTN_H_
#define ___CCOLORBTN_H_

class CColorButton : public CButton
{
DECLARE_DYNAMIC(CColorButton)

private:
	COLORREF	coltext;		// LvVJ[(ʏ펞)
	COLORREF	colbackground;	// wiF
	COLORREF	coldisabled;	// {^̃LvVJ[

public:
	// RXgN^EfXgN^
	CColorButton(); 
	virtual ~CColorButton(); 

	// o֐
	BOOL AutoLoad(const UINT nID, CWnd* pParent);							// {^CColorButtonɃA^b`
	void SetTextColor(const COLORREF color){coltext = color;}				// LvVJ[ݒ
	void SetBackGroundColor(const COLORREF color);							// wiFݒ
    void SetDisabledColor(const COLORREF color){coldisabled = color;}		// {^̃LvVJ[ݒ
	COLORREF GetTextColor() { return coltext; }								// LvVJ[擾
	COLORREF GetBackGroundColor() { return colbackground; }					// wiF擾
    COLORREF GetDisabledColor() { return coldisabled; }						// {^̃LvVJ[擾

protected:
    void PreSubclassWindow();												// I[i[`
	virtual void DrawItem(LPDRAWITEMSTRUCT lpDIS);							// {^̃I[i[`
	void DrawBkGround(CDC *pDC, CRect rect,const COLORREF color);			// wiF`
	void DrawCaption(CDC *pDC, CRect rect,const COLORREF color,const CString& str);
																			// LvV`
};
#endif 
